function [X_tr, Y_tr, X_te, Y_te, features_to_keep, groups, groupnames] = EDC_preprocess_20newsgroups(nb_indices_to_keep)

%% Load 20Newsgroups data and take subject 1 newsgroup group vs the others,
% Explain each model

% Now stratified: when sampling, equal from each class

groups = {[1],...
    %     alt.atheism - [1 
    [2:6],...
    %     comp.graphics [320
    %     comp.os.ms-windows.misc [709
    %     comp.sys.ibm.pc.hardware [1103
    %     comp.sys.mac.hardware [1495
    %     comp.windows.x [1880
    [7],...
    %     misc.forsale [2275
    [8:11],...
    %     rec.autos         [2665
    %     rec.motorcycles   [3061
    %     rec.sport.baseball[3459
    %     rec.sport.hockey  [3856
    [12:15],...
    %     sci.crypt         [4255
    %     sci.electronics   [4651
    %     sci.med           [5044
    %     sci.space         [5440
    [16],...
    %     soc.religion.christian [5834
    [17:20],...
    %     talk.politics.guns     [6232
    %     talk.politics.mideast  [6596
    %     talk.politics.misc     [6972
    %     talk.religion.misc     [7282
    };
groupnames = {'alt','comp','misc','rec','sci','soc','talk'};

%nb_indices_to_keep = 50; % 20;

%cd 'C:\Documents and Settings\dmartens\My Documents\Research\Explaining Classifications\Datasets'
cd 'D:\Data folder\20newsgroups'
load 20NewsGroups

% From http://www.zjucadcg.cn/dengcai/Data/TextData.html
% We provide here the tf vector of each document. One can use the following codes to generate the tf-idf vector. ([1+log(tf)]*log[N/df])
%===========================================
[nSmp,nFea] = size(fea);
[idx,jdx,vv] = find(fea);

df = full(sum(sparse(idx,jdx,1),1));
idf = log(nSmp./df);

tffea = sparse(idx,jdx,log(vv)+1);

fea2 = tffea';
idf = idf';
for i = 1:nSmp
    fea2(:,i) = fea2(:,i) .* idf;
end
%===========================================
fea3 = fea2';
fea2= fea3;

%===========================================
feaTrain = fea2(trainIdx,:);
gndTrain = gnd(trainIdx,:);

feaTest = fea2(testIdx,:);
gndTest = gnd(testIdx,:);
%===========================================

%save prepr20newsgr gndTrain feaTrain feaTest gndTest groups groupnames

%% Feature selection based on MI
%load prepr20newsgr
%cd 'C:\Documents and Settings\dmartens\My Documents\Research\Explaining Classifications\Datasets'
features = textread('features2.txt','%s');

classes = unique(gndTrain);
nb_classes = size(classes,1);
s2 = size(feaTrain,2);
s1 = size(feaTrain,1);
features_to_keep_ind = [];

startindices = zeros(nb_classes,1); % This for stratified sampling

for class_i = 1:nb_classes
    %    class_i
    Yc = zeros(s1,1);
    class = classes(class_i);
    ind = find(gndTrain == class_i);

    startindices(class_i) = ind(1); % This for stratified sampling
    
    Yc(ind)=1;
    h = zeros(s2,1);
    for i=1:s2
        A = feaTrain(:,i);
        h(i) = mutualinfo(full(A), Yc);
    end
    [h_sort,I] = sort(h);
    features_to_keep_ind = [features_to_keep_ind I(s2-nb_indices_to_keep+1:s2)];
    %   features(features_to_keep_ind)
end
features_to_keep_ind = unique(features_to_keep_ind);
features_to_keep = features(features_to_keep_ind);

%save features features_to_keep

X_tr = full(feaTrain(:,features_to_keep_ind));
Y_tr = gndTrain;

X_te = full(feaTest(:,features_to_keep_ind));
Y_te = gndTest;
