%% Load 20Newsgroups data and take subject 1 newsgroup group vs the others,
% Explain each model

% Now stratified: when sampling, equal from each class

groups = {[1],...
    %     alt.atheism - [1 
    [2:6],...
    %     comp.graphics [320
    %     comp.os.ms-windows.misc [709
    %     comp.sys.ibm.pc.hardware [1103
    %     comp.sys.mac.hardware [1495
    %     comp.windows.x [1880
    [7],...
    %     misc.forsale [2275
    [8:11],...
    %     rec.autos         [2665
    %     rec.motorcycles   [3061
    %     rec.sport.baseball[3459
    %     rec.sport.hockey  [3856
    [12:15],...
    %     sci.crypt         [4255
    %     sci.electronics   [4651
    %     sci.med           [5044
    %     sci.space         [5440
    [16],...
    %     soc.religion.christian [5834
    [17:20],...
    %     talk.politics.guns     [6232
    %     talk.politics.mideast  [6596
    %     talk.politics.misc     [6972
    %     talk.religion.misc     [7282
    };
groupnames = {'alt','comp','misc','rec','sci','soc','talk'};

nb_indices_to_keep = 50; % 20;

cd 'C:\Documents and Settings\dmartens\My Documents\Research\Explaining Classifications\Datasets'
load 20NewsGroups

% From http://www.zjucadcg.cn/dengcai/Data/TextData.html
% We provide here the tf vector of each document. One can use the following codes to generate the tf-idf vector. ([1+log(tf)]*log[N/df])
%===========================================
[nSmp,nFea] = size(fea);
[idx,jdx,vv] = find(fea);

df = full(sum(sparse(idx,jdx,1),1));
idf = log(nSmp./df);

tffea = sparse(idx,jdx,log(vv)+1);

fea2 = tffea';
idf = idf';
for i = 1:nSmp
    fea2(:,i) = fea2(:,i) .* idf;
end
%===========================================
fea3 = fea2';
fea2= fea3;

%===========================================
feaTrain = fea2(trainIdx,:);
gndTrain = gnd(trainIdx,:);

feaTest = fea2(testIdx,:);
gndTest = gnd(testIdx,:);
%===========================================

save prepr20newsgr gndTrain feaTrain feaTest gndTest groups groupnames

%% Feature selection based on MI
load prepr20newsgr
cd 'C:\Documents and Settings\dmartens\My Documents\Research\Explaining Classifications\Datasets'
features = textread('features.txt','%s');

classes = unique(gndTrain);
nb_classes = size(classes,1);
s2 = size(feaTrain,2);
s1 = size(feaTrain,1);
features_to_keep_ind = [];

startindices = zeros(nb_classes,1); % This for stratified sampling

for class_i = 1:nb_classes
    %    class_i
    Yc = zeros(s1,1);
    class = classes(class_i);
    ind = find(gndTrain == class_i);

    startindices(class_i) = ind(1); % This for stratified sampling
    
    Yc(ind)=1;
    h = zeros(s2,1);
    for i=1:s2
        A = feaTrain(:,i);
        h(i) = mutualinfo(full(A), Yc);
    end
    [h_sort,I] = sort(h);
    features_to_keep_ind = [features_to_keep_ind I(s2-nb_indices_to_keep+1:s2)];
    %   features(features_to_keep_ind)
end
features_to_keep_ind = unique(features_to_keep_ind);
features_to_keep = features(features_to_keep_ind);

save features features_to_keep

X_tr = full(feaTrain(:,features_to_keep_ind));
Y_tr = gndTrain;

X_te = full(feaTest(:,features_to_keep_ind));
Y_te = gndTest;

%% Classify one group versus another
load prepr20newsgr
load features
nb_groups = size(groups,1);
sampled_nb_instances = 1000;

for groupi = [nb_groups:-1:1]
    
    ingroup = groups{groupi};
    % Eg: group 2 is computer (class 2 to 6) versus non-computer subjects
    % Take random selection of 'sampled_nb_instances' instances for each class


    indices_computer_tr = find(Y_tr >= min(ingroup) & Y_tr <= max(ingroup));
    X_tr_comp = X_tr(indices_computer_tr,:);
    Y_tr_comp = ones(size(indices_computer_tr,1),1);
    indices_noncomputer_tr = setdiff([1:size(X_tr,1)],indices_computer_tr)';
    X_tr_noncomp = X_tr(indices_noncomputer_tr,:);
    Y_tr_noncomp = - ones(size(indices_noncomputer_tr,1),1);

    indices_computer_te = find(Y_te >= min(ingroup) & Y_te <= max(ingroup));
    Y_te_compvsnoncomp = ones(size(Y_te,1),1);
    X_te_comp = X_te(indices_computer_te,:);
    indices_noncomputer_te = setdiff([1:size(X_te,1)],indices_computer_te)';
    X_te_noncomp = X_te(indices_noncomputer_te,:);
    Y_te_compvsnoncomp(indices_noncomputer_te) = -1;

	% Take sample from each class
    sel_comp = randperm(size(X_tr_comp,1));
    sel_noncomp = randperm(size(X_tr_noncomp,1));
    
    % This for stratified sampling
    % Take equal nb from each class:
    indices_sample_tr = [];
    classes_noncomp = setdiff([1:nb_classes],ingroup);
    samplenb_per_class = floor(sampled_nb_instances/size(classes_noncomp,2));
        for ci=classes_noncomp
        indices_ci = find(Y_tr_noncomp == ci);
        sel_sampl_ci = randperm(size(indices_ci,1));
        sss = min(samplenb_per_class,size(indices_ci,1));
        indices_sample_tr = [indices_sample_tr;indices_ci(sel_sampl_ci(1:sss))];
        end
    nb_to_add = round(sampled_nb_instances/2) - size(indices_sample_tr,1);
    indices_sample_tr = [indices_sample_tr sel_noncomp(1:nb_to_add)];
    
        % In some cases less than 1000 to sample
    sampled_nb_instances2 = min(sampled_nb_instances,size(sel_comp,2));
    
%    X_tr_sample = [X_tr_comp(sel_comp(1:sampled_nb_instances2),:); X_tr_noncomp(sel_noncomp(1:sampled_nb_instances),:)];
    X_tr_sample = [X_tr_comp(sel_comp(1:sampled_nb_instances2),:); X_tr(indices_sample_tr,:)];
    

    % Always 1000 of noncomp
%    X_tr_sample = [X_tr_comp(sel_comp(1:sampled_nb_instances2),:); X_tr_noncomp(sel_noncomp(1:sampled_nb_instances),:)];
    Y_tr_sample = [Y_tr_comp(sel_comp(1:sampled_nb_instances2),:); Y_tr(indices_sample_tr,:)];

    %% Run LS-SVM
    type = 'classification';
    %L_fold = 3; % L-fold crossvalidation
    %[Ycode, codebook, old_codebook] = code(Y_tr,'code_MOC');
    %     fprintf(1,'Tuning SVM...');
    %[gam,sig2] = tunelssvm({X_tr,Y_tr2,type,1,1,'lin_kernel'},[],'gridsearch',{},'crossvalidate',{X_tr,Y_tr2,L_fold,'misclass'});
    %    fprintf(1,'done\n');    
    %    gam = 0.47676;
    gam = 1;
    sig2 = 100;
    fprintf(1,'Training SVM...');
    [alpha,b] = trainlssvm({X_tr_sample,Y_tr_sample,type,gam,sig2,'lin_kernel'});
    fprintf(1,'done\n');
    Yte_sim = simlssvm({X_tr_sample,Y_tr_sample,type,gam,sig2,'lin_kernel'},{alpha,b},X_te);
    Ytr_sim = simlssvm({X_tr_sample,Y_tr_sample,type,gam,sig2,'lin_kernel'},{alpha,b},X_tr_sample);

    corrects_tr = size(find(Ytr_sim == Y_tr_sample),1);
    PCC_tr = corrects_tr / size(Ytr_sim,1)
    corrects_te = size(find(Yte_sim == Y_te_compvsnoncomp),1);
    PCC_te = corrects_te / size(Yte_sim,1)

    alpham = alpha;
    save bb_SVM_sample_compvsnoncomp

    %% Explain
    %load bb_SVM_sample_compvsnoncomp
    Explained = [];
    Avg_time = [];
    for classi=1:20
        indices = find(gndTest == classi);
        i_start=indices(1);
        i_end=indices(10);
        [avg_e,avg_t] = explain_docs_heuristicly_aproach2_withstop_str(i_start,i_end,groupnames{groupi});
        Explained = [Explained;avg_e];
        Avg_time = [Avg_time;avg_t];
    end
end
% lambda = 100;
% w = LassoGaussSeidel(X_tr,Y_tr2,lambda);
%
% w'*X_tr'
%
