function [word_combos2,probs2] = remove_combinations2(word_combos,word_combos_explained,probs,max_nb_of_words)
% Remove combinations that are explained 
% Remove the combination that was just expanded on
% Remove all combinations that can not be expanded upon as the max nb of words is reached.
% Also remove their probabilities such that there remains a one to one relationship

s1  = size(word_combos_explained,2);
s2  = size(word_combos,1);
nbwords = size(word_combos,2);
word_combos2 = [];
probs2 = [];
for j=1:s2
    %combs = cell2mat(comb);
    wc = word_combos(j,:);
    add = 1;
    if (min(wc) > 0)
        % Max nb of words reached: can not be expanded upon
        add = 0;
    else
        for i=1:s1
            combs = word_combos_explained{i};
            N = setdiff(wc,combs);
            sN = size(find(N > 0),2);
            swc = size(find(wc > 0),2);
            scombs = size(find(combs > 0),2);
            if(sN == swc - scombs)
                add = 0;
            end
        end
    end
    if (add == 1)
        word_combos2 = [word_combos2;wc];
        probs2 = [probs2;probs(j)];
    end
end

