function best_C = tune_libSVM(Y, data, options)
% Tunes the C parameter.

best_perf = 0;
range = [0.00001 0.0001 0.001 0.01 0.1 1 10];
perfs_val = zeros(size(range,2),1);
for regi = 1:size(range,2)
    perfs_val(regi) = train(Y, data, [options,' -v 10 -c ',num2str(range(regi))]);
    if perfs_val(regi) > best_perf
        best_perf = perfs_val(regi);
        best_C = range(regi);
    end
end